#include<iostream>
#include<fstream>
#include<iomanip>
#include<time.h>
using namespace std;

//void main()
//{
//	int* p = NULL;
//	int x = 8;
//	cout << x;
//	p = &x;
//	cout << *p << endl;
//	
//	cin >> x;
//	while (true)
//	{
//		p = new int[x];
//		delete[] p;
//	}
//	*p = 7;
//	cout << *p << endl;
//
//	delete[] p;
//}


struct FileHeader
{
	char FileType[2];
	unsigned long bfSize;
	unsigned short bfReserved1;
	unsigned short bfReserved2;
	unsigned long bfOffBits;
};

struct ImageHeader
{
	unsigned long biSize;
	unsigned long biWidth;
	unsigned long biHeight;
	unsigned short biPlanes;
	unsigned short biBitCount;
	unsigned long biCompression;
	unsigned long biSizeImage;
	unsigned long biXPixelsPerMeter;
	unsigned long biYPixelsPerMeter;
	unsigned long biClrUsed;
	unsigned long biClrImportant;

	unsigned long PixelCount;	//# of pixles in file
};

struct RGBTriple
{
	unsigned char Blue;
	unsigned char Green;
	unsigned char Red;
};

struct Picture
{
	FileHeader fileHeader;
	ImageHeader imageHeader;
	RGBTriple* Pixels;
};

void ReadFileHeader(FileHeader& fileHeader, ifstream& fin)
{
	fin.seekg(0);
	fin.read(fileHeader.FileType, 2);
	fin.read((char*)&fileHeader.bfSize, 4);
	fin.read((char*)&fileHeader.bfReserved1, 2);
	fin.read((char*)&fileHeader.bfReserved2, 2);
	fin.read((char*)&fileHeader.bfOffBits, 4);
}

void WriteFileHeader(const FileHeader& fileHeader, ofstream& fout)
{
	fout.seekp(0);
	fout.write(fileHeader.FileType, 2);
	fout.write((char*)&fileHeader.bfSize, 4);
	fout.write((char*)&fileHeader.bfReserved1, 2);
	fout.write((char*)&fileHeader.bfReserved2, 2);
	fout.write((char*)&fileHeader.bfOffBits, 4);
}


void DisplayFileHeader(const FileHeader& fileHeader)
{
	cout << endl;
	cout << setw(20) << "File Header bytes 0-13 " << endl;
	cout << setw(20) << "File Type - " << fileHeader.FileType[0] << fileHeader.FileType[1] << endl;
	cout << setw(20) << "bfSize - " << fileHeader.bfSize << endl;
	cout << setw(20) << "bfReserved1 - " << fileHeader.bfReserved1 << endl;
	cout << setw(20) << "bfReserved2 - " << fileHeader.bfReserved2 << endl;
	cout << setw(20) << "bfOffBits - " << fileHeader.bfOffBits << endl;
	cout << endl;
}

void ReadimageHeader(ImageHeader& imageHeader, ifstream& fin)
{
	fin.seekg(14);
	fin.read((char*)&imageHeader.biSize, 4);
	fin.read((char*)&imageHeader.biWidth, 4);
	fin.read((char*)&imageHeader.biHeight, 4);
	fin.read((char*)&imageHeader.biPlanes, 2);
	fin.read((char*)&imageHeader.biBitCount, 2);
	fin.read((char*)&imageHeader.biCompression, 4);
	fin.read((char*)&imageHeader.biSizeImage, 4);
	fin.read((char*)&imageHeader.biXPixelsPerMeter, 4);
	fin.read((char*)&imageHeader.biYPixelsPerMeter, 4);
	fin.read((char*)&imageHeader.biClrUsed, 4);
	fin.read((char*)&imageHeader.biClrImportant, 4);

	imageHeader.PixelCount = imageHeader.biHeight * imageHeader.biWidth;
}

void WriteimageHeader(const ImageHeader& imageHeader, ofstream& fout)
{
	fout.seekp(14);
	fout.write((char*)&imageHeader.biSize, 4);
	fout.write((char*)&imageHeader.biWidth, 4);
	fout.write((char*)&imageHeader.biHeight, 4);
	fout.write((char*)&imageHeader.biPlanes, 2);
	fout.write((char*)&imageHeader.biBitCount, 2);
	fout.write((char*)&imageHeader.biCompression, 4);
	fout.write((char*)&imageHeader.biSizeImage, 4);
	fout.write((char*)&imageHeader.biXPixelsPerMeter, 4);
	fout.write((char*)&imageHeader.biYPixelsPerMeter, 4);
	fout.write((char*)&imageHeader.biClrUsed, 4);
	fout.write((char*)&imageHeader.biClrImportant, 4);
}

void DisplayimageHeader(const ImageHeader& imageHeader)
{
	cout << endl;
	cout << setw(20) << "Info Header bytes 14-53 " << endl;
	cout << setw(20) << "biSize - " << imageHeader.biSize << endl;
	cout << setw(20) << "biWidth - " << imageHeader.biWidth << endl;
	cout << setw(20) << "biHeight - " << imageHeader.biHeight << endl;
	cout << setw(20) << "biPlanes - " << imageHeader.biPlanes << endl;
	cout << setw(20) << "biBitCount - " << imageHeader.biBitCount << endl;
	cout << setw(20) << "biCompression - " << imageHeader.biCompression << endl;
	cout << setw(20) << "biSizeImage - " << imageHeader.biSizeImage << endl;
	cout << setw(20) << "biXPixelsPerMeter - " << imageHeader.biXPixelsPerMeter << endl;
	cout << setw(20) << "biYPixelsPerMeter - " << imageHeader.biYPixelsPerMeter << endl;
	cout << setw(20) << "biClrUsed - " << imageHeader.biClrUsed << endl;
	cout << setw(20) << "biClrImportant - " << imageHeader.biClrImportant << endl;
	cout << setw(20) << "PixelCount - " << imageHeader.PixelCount << endl;
	cout << endl;
}

void DisplayHeaders(const Picture& picture)
{
	DisplayFileHeader(picture.fileHeader);
	DisplayimageHeader(picture.imageHeader);
}

void ReadFile(const char* FileName, Picture& picture)
{
	ifstream fin;
	fin.open(FileName, ios_base::binary);

	ReadFileHeader(picture.fileHeader, fin);
	ReadimageHeader(picture.imageHeader, fin);

	//Get Memory for picture's Pixels
	//asks the OS for n new RGBTriples
	picture.Pixels = new RGBTriple[picture.imageHeader.PixelCount];

	fin.seekg(picture.fileHeader.bfOffBits); //should be 54
	int i = 0;
	for (unsigned int row = 0; row < picture.imageHeader.biHeight; row++)
	{
		for (unsigned int column = 0; column < picture.imageHeader.biWidth; column++, i++)
		{
			fin.read((char*)&(picture.Pixels[i]), 3);
		}

		unsigned int BytesRead = picture.imageHeader.biWidth * 3;
		unsigned char junk;

		while (BytesRead % 4 != 0)
		{
			fin.read((char*)&junk, 1);
			BytesRead++;
		}
	}

	fin.close();
}

void WriteFile(const char* FileName, const Picture& picture)
{
	ofstream fout;
	fout.open(FileName, ios_base::binary); //destroys the old file

	WriteFileHeader(picture.fileHeader, fout);
	WriteimageHeader(picture.imageHeader, fout);

	fout.seekp(picture.fileHeader.bfOffBits); //should be 54
	int i = 0;
	for (unsigned int row = 0; row < picture.imageHeader.biHeight; row++)
	{
		for (unsigned int column = 0; column < picture.imageHeader.biWidth; column++, i++)
		{
			fout.write((char*)&(picture.Pixels[i]), 3);
		}

		unsigned int  b = picture.imageHeader.biWidth * 3;
		unsigned char junk = 0;

		while (b % 4 != 0)
		{
			fout.write((char*)&junk, 1);
			b = b + 1;
		}
	}
	fout.close();
}

void InvertColors(Picture& picture)
{
	for (unsigned int i = 0; i < picture.imageHeader.PixelCount; i++)
	{
		picture.Pixels[i].Blue = 255 - picture.Pixels[i].Blue;
		picture.Pixels[i].Green = 255 - picture.Pixels[i].Green;
		picture.Pixels[i].Red = 255 - picture.Pixels[i].Red;
	}
}

void AddSaltAndPepper(Picture& picture)
{
	srand((unsigned int)time(NULL));
	for (unsigned int i = 0; i < picture.imageHeader.PixelCount; i++)
	{
		if (rand() % 100 == 0)
		{
			if (rand() % 2 == 0)
			{
				picture.Pixels[i].Blue = (unsigned char)0;
				picture.Pixels[i].Green = (unsigned char)0;
				picture.Pixels[i].Red = (unsigned char)0;
			}
			else
			{
				picture.Pixels[i].Blue = (unsigned char)255;
				picture.Pixels[i].Green = (unsigned char)255;
				picture.Pixels[i].Red = (unsigned char)255;
			}
		}
	}
}

void Reverse(Picture picture)
{
	int Front = 0;
	int Back = picture.imageHeader.PixelCount - 1;
	RGBTriple Pixel;

	while (Front < Back)
	{
		//swap Fron & Back
		Pixel = picture.Pixels[Front];
		picture.Pixels[Front] = picture.Pixels[Back];
		picture.Pixels[Back] = Pixel;

		Front++;
		Back--;
	}
}

void Rotate90(Picture& picture)
{
	int NewHeight = picture.imageHeader.biWidth;
	int NewWidth = picture.imageHeader.biHeight;

	//get memory for new picture
	RGBTriple* NewPixels = new RGBTriple[picture.imageHeader.PixelCount];

	int i = 0;
	for (int column = picture.imageHeader.biWidth - 1; column >= 0; column--)
	{
		for (unsigned int row = 0; row < picture.imageHeader.biHeight; row++, i++)
		{
			NewPixels[i] = picture.Pixels[row * picture.imageHeader.biWidth + column];
		}
	}

	//switch Pixels
	delete[] picture.Pixels;
	picture.Pixels = NewPixels;

	unsigned long Temp = picture.imageHeader.biWidth;
	picture.imageHeader.biWidth = picture.imageHeader.biHeight;
	picture.imageHeader.biHeight = Temp;
}

void Rotate180(Picture& picture)
{
}

void Rotate270(Picture& picture)
{
}

void FlipVertical(Picture& picture)
{
}

void FlipHorizontal(Picture& picture)
{
}

void DoubleSize(Picture& picture)
{
	//get memory for new picture
	RGBTriple* NewPixels = new RGBTriple[picture.imageHeader.PixelCount * 4];

	int i = 0;
	for (int row = 0; row < picture.imageHeader.biHeight; row++)
	{
		for (int column = 0; column < picture.imageHeader.biWidth; column++, i++)
		{
			NewPixels[i] = picture.Pixels[row * picture.imageHeader.biWidth + column];
			i++;
			NewPixels[i] = picture.Pixels[row * picture.imageHeader.biWidth + column];
		}
		for (int column = 0; column < picture.imageHeader.biWidth; column++, i++)
		{
			NewPixels[i] = picture.Pixels[row * picture.imageHeader.biWidth + column];
			i++;
			NewPixels[i] = picture.Pixels[row * picture.imageHeader.biWidth + column];
		}
	}

	//switch Pixels
	delete[] picture.Pixels;
	picture.Pixels = NewPixels;

	picture.imageHeader.biWidth *= 2;
	picture.imageHeader.biHeight *= 2;
}



void main()
{
	char FileName[100];
	cin.getline(FileName, 100);

	Picture picture;

	ReadFile(FileName, picture);
	DisplayHeaders(picture);

	////your program
	InvertColors(picture);
	//Reverse(Picture);
	//Rotate90(Picture);
	//FlipVertical(Picture);
	//FlipHorizontal(Picture);
	//DoubleSize(picture);
	//AddSaltAndPepper(Picture);
	DisplayHeaders(picture);


	WriteFile(FileName, picture);
}
